Pascal's Travels (HDU 1208)

来源:互联网 发布:优化网络连接 编辑:程序博客网 时间:2024/06/03 14:53

Pascal's Travels

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 1682    Accepted Submission(s): 732


Problem Description
An n x n game board is populated with integers, one nonnegative integer per square. The goal is to travel along any legitimate path from the upper left corner to the lower right corner of the board. The integer in any one square dictates how large a step away from that location must be. If the step size would advance travel off the game board, then a step in that particular direction is forbidden. All steps must be either to the right or toward the bottom. Note that a 0 is a dead end which prevents any further progress.


Consider the 4 x 4 board shown in Figure 1, where the solid circle identifies the start position and the dashed circle identifies the target. Figure 2 shows the three paths from the start to the target, with the irrelevant numbers in each removed.


Figure 1


Figure 2

Input
The input contains data for one to thirty boards, followed by a final line containing only the integer -1. The data for a board starts with a line containing a single positive integer n, 4 <= n <= 34, which is the number of rows in this board. This is followed by n rows of data. Each row contains n single digits, 0-9, with no spaces between them.

Output
The output consists of one line for each board, containing a single integer, which is the number of paths from the upper left corner to the lower right corner. There will be fewer than 2^63 paths for any board.

Sample Input
423311213123131104333212131232212051110101111111111110111101-1

Sample Output
307
Hint
Hint
Brute force methods examining every path will likely exceed the allotted time limit. 64-bit integer values are available as "__int64" values using the Visual C/C++ or "long long" values using GNU C/C++ or "int64" values using Free Pascal compilers.

Source
Mid-Central USA 2005
 
题意:给你n*n的方格,每个方格里面一个数字,代表能从那个格子能跳几格(直接跳,不经过中间格),只能往下跳或往右跳,问从左上角到右下角有几种跳法。
 
 
这题可以用记忆化搜索来解决,不过我不太会,没写出来。。不过也可以直接用DP来做,
#include<stdio.h>#include<string.h>int main(){    int n, i, j, p[50][50];    __int64 dp[50][50]; //dp表示路经过的次数    char x[50];    while(~scanf("%d", &n), n+1)    {        for(i=0; i<n; i++)        {            scanf("%s", x);            for(j=0; j<n; j++)                p[i][j] = x[j]-'0';        }        memset(dp, 0, sizeof(dp));        dp[0][0] = 1;         for(i=0; i<n; i++)        {            for(j=0; j<n; j++)            {                if(!p[i][j]) continue; //当为0时直接pass掉                dp[i+p[i][j]][j] += dp[i][j]; //由于数组开大了,所以越界问题不会影响结果                dp[i][j+p[i][j]] += dp[i][j];            }        }        printf("%I64d\n", dp[n-1][n-1]);    }    return 0;}

0 0
原创粉丝点击